Skip site navigation (1)Skip section navigation (2)
Date:      Sat, 25 Jul 2009 10:22:09 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-projects@freebsd.org
Subject:   svn commit: r195864 - projects/stress2/misc
Message-ID:  <200907251022.n6PAM98R037059@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Sat Jul 25 10:22:08 2009
New Revision: 195864
URL: http://svn.freebsd.org/changeset/base/195864

Log:
  Added test scenario for NFS intr mount and SIGSTOP.

Added:
  projects/stress2/misc/nfs8.sh   (contents, props changed)

Added: projects/stress2/misc/nfs8.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/nfs8.sh	Sat Jul 25 10:22:08 2009	(r195864)
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test scenario for a lock cascade problem with sending SIGSTOP to processes
+# accessing a NFS intr mount.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+[ ! -d $mntpoint ] &&  mkdir $mntpoint
+mount | grep "$mntpoint" | grep nfs > /dev/null && umount $mntpoint
+mount -t nfs -o nfsv3,tcp,nolockd -o retrycnt=3 -o intr -o soft -o rw 127.0.0.1:/tmp $mntpoint
+
+pids=""
+for i in `jot 10`; do
+	find $mntpoint > /dev/null 2>&1 &
+	sleep 0.1
+	kill -s STOP $!
+	pids="$pids $!"
+done
+
+umount $mntpoint 2>&1 | grep -v "Device busy"
+while mount | grep -q $mntpoint; do
+	umount -f $mntpoint > /dev/null 2>&1
+done
+
+kill -s CONT $pids
+for i in `jot 10`; do
+	wait
+done



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?200907251022.n6PAM98R037059>